<template>
  <div v-if="category">
    <div class="container category">
      {{ category }}
      <div class="input-group">
        <div class="form-outline">
          <input
            type="search"
            v-model="search"
            id="form1"
            class="form-control"
          />
        </div>
      </div>
      <select class="form-select" v-model="selected">
        <option value="descending">Note Décroissante</option>
        <option value="ascending">Note Croissante</option>
        <option value="az">Ordre Alphabétique</option>
        <option value="za">Ordre Alphabétique Inversé</option>
      </select>
    </div>
    <div v-if="isLoading">Loading ...</div>

    <div class="container">
      <div class="row row-cols-auto justify-content-between">
        <ProductItem
          v-for="product in filteredProducts"
          :key="product.id"
          :product="product"
        />
      </div>
    </div>
  </div>
</template>

<script setup>
import ProductItem from '@/components/ProductItem.vue'
import { ref, computed } from 'vue'
import { getData } from '@/categories'

const props = defineProps({
  categoryName: {
    type: String,
    required: true
  },
  limit: {
    type: Number,
    default: 20
  }
})

const categories = ref([])
const products = ref([])
const isLoading = ref(false)
const search = ref('')
const selected = ref('descending')

getData().then((data) => (categories.value = data))

const category = computed(() =>
  categories.value.find((c) => c === props.categoryName)
)

const searchProducts = async () => {
  isLoading.value = true
  try {
    fetch(`https://fakestoreapi.com/products/category/${props.categoryName}`)
      .then((res) => res.json())
      .then((json) => {
        products.value = json
      })
  } catch {
    alert('An error occured!')
  }
  isLoading.value = false
}

const filteredProducts = computed(() => {
  let tempProducts = products.value

  if (search.value != '' && search.value) {
    tempProducts = tempProducts.filter((item) => {
      return item.title.toUpperCase().includes(search.value.toUpperCase())
    })
  }

  switch (selected.value) {
    case 'descending':
      tempProducts = tempProducts
        .sort((a, b) => {
          let fa = parseFloat(a.rating?.rate),
            fb = parseFloat(b.rating?.rate)

          if (fa < fb) {
            return -1
          }
          if (fa > fb) {
            return 1
          }
        })
        .reverse()
      break
    case 'ascending':
      tempProducts = tempProducts.sort((a, b) => {
        let fa = parseFloat(a.rating?.rate),
          fb = parseFloat(b.rating?.rate)

        if (fa < fb) {
          return -1
        }
        if (fa > fb) {
          return 1
        }
      })
      break
    case 'az':
      tempProducts = tempProducts.sort((a, b) => {
        let fa = a.title.toLowerCase(),
          fb = b.title.toLowerCase()

        if (fa < fb) {
          return -1
        }
        if (fa > fb) {
          return 1
        }
      })
      break
    case 'za':
      tempProducts = tempProducts
        .sort((a, b) => {
          let fa = a.title.toLowerCase(),
            fb = b.title.toLowerCase()

          if (fa < fb) {
            return -1
          }
          if (fa > fb) {
            return 1
          }
        })
        .reverse()
      break

    default:
      break
  }

  return tempProducts
})

searchProducts()
</script>

<style lang="scss" scoped>
.section-products {
  padding: 80px 0 54px;
}

.category {
  font-family: 'Poppins', sans-serif;
  font-size: 2em;
  font-weight: bold;
  text-transform: capitalize;
}
.ProductList {
  display: flex;
  flex-direction: column;
  gap: 2rem;
}
</style>
